/*-----------------------------*/
/*      place.cpp              */
/* class Place function        */
/* 2003.06.10 MIRS0204         */
/*-----------------------------*/


#include "place.h"
#include <math.h>

#define PI 3.14159265

Place::Place(double a=0, double b=0,coordinates c=cartesian)
{
	switch(c){
	case cartesian:     //Cartesian
		m_x=a;
		m_y=b;
		m_r=sqrt(a*a + b*b);
		m_a=atan2(a,b)*360/(2*PI);
		break;
	case polar:    //Polar
		m_x=a*cos(b*(2*PI)/360);
		m_y=a*sin(b*(2*PI)/360);
		m_r=a;
		m_a=b;
		break;
	default:
		m_x=0;
		m_y=0;
		m_r=0;
		m_a=0;
		printf("Coordinates name Error!\n class Place::Place()\n");
		break;
	}
}

Place::~Place(void)
{
	
}

void Place::setPlace(double a=0, double b=0,coordinates c=cartesian)
{
	switch(c){
	case cartesian:     //Cartesian
		m_x=a;
		m_y=b;
		m_r=sqrt(a*a + b*b);
		m_a=atan2(a,b)*360/(2*PI);
		break;
	case polar:    //Polar
		m_x=a*cos(b*(2*PI)/360);
		m_y=a*sin(b*(2*PI)/360);
		m_r=a;
		m_a=b;
		break;
	default:
		m_x=0;
		m_y=0;
		m_r=0;
		m_a=0;
		printf("Coordinates name Error!\n class Place::setPlace()\n");
		break;
	}
}

double Place::getPlaceX(void)
{
	return m_x;
}

double Place::getPlaceY(void)
{
	return m_y;
}

double Place::getPlaceR(void)
{
	return m_r;
}

double Place::getPlaceA(void)
{
	return m_a;
}

double Place::getPlaceD(void)
{
	return m_d;
}
