/*-----------------------------*/
/*      uss.cpp                */
/*     class Uss               */
/* 2003.11.17 MIRS0204         */
/*-----------------------------*/

#include <iostream.h>
#include <string.h> // memset(3)
#include <stdlib.h> // exit(1)

#include <unistd.h> /* close() ,read(2)*/
#include <fcntl.h> /* open(2) */
#include <sys/ioctl.h> /* ioctl(2) */
#include <sys/time.h>
#include <sys/types.h>

//#include <rtl_cpp.h>
//#include <rtl_fifo.h>
//#include <rtl_time.h>
//#include <rtl_debug.h>

#include "uss.h"

Uss::Uss(void)
{
	if ((fd = open("/dev/rtf2",O_RDONLY)) < 0) {
		cerr << "ERROR: uss can't open. /dev/rtf2" << endl;
		exit(EXIT_FAILURE);
	}
	if ((ctl = open("/dev/rtf1",O_WRONLY)) < 0) {
		cerr << "ERROR: uss can't open. /dev/rtf1" << endl;
		exit(EXIT_FAILURE);
	}
	
	// initialize value[]
	memset(value, 0, sizeof(value));
}

Uss::~Uss(void)
{
	close(fd);
	close(ctl);
}

Uss::operator int(void)
{
	int ret;
	if((fd<0) && (ctl<0)){
		ret = 0;
	}else{
		ret = -1;
	}
	return ret;
}
int Uss::getValue(const int num)
{
	int buf;
	fd_set rfds;
	struct timeval tv;
	int retval;
	int cmd = num;
	
	if ((num<0) || (num>3)) {
		cerr << "Error: Uss::getValue(const int num), wrong arg." << endl;
		return -1;
	}
	
	if (write(ctl, &cmd, sizeof(int)) < 0) {
		cout << "uss transmit: now sending command to uss No." << num << '\n';
	}
	
	FD_ZERO(&rfds);
	FD_SET(fd,&rfds);
	tv.tv_sec = 0;
	tv.tv_usec = 20000;
	
	retval = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
	if (retval > 0) {
		if(FD_ISSET(fd,&rfds)) {
			read(fd, &buf,sizeof(buf));
			if(buf < 200){
				buf = 0;
			}
			value[num] = buf;
		}
	}else{
		value[num] = -1;
	}
	
	return value[num];
}
