/*-------------------------------------------*/
/*      ts_dcp.c                             */
/* TS & DCP Device Driver Program            */
/*                       2003.11.18 MIRS0204 */
/*-------------------------------------------*/

#define __KERNEL__
#define MODULE

#include <linux/module.h> /* MOD_INC_USE_COUNT ʤ*/
#include <linux/fs.h>
#include <linux/errno.h> /* EBUSY */
#include <linux/ioctl.h>
#include <linux/ioport.h>
#include <asm/segment.h>
#include <asm/uaccess.h>
#include <asm/io.h> /* inw() Ŭץɬ */

#define TS_DCP_MAJOR 61 /* Device identifier */
#define TS_READ_ADDR 0x0140 /* I/O port */
#define TS_MASK_ADDR 0x0142

/*-------------------------------------------*/
/*    ts_dcp_open()                          */
/*-------------------------------------------*/
static int ts_dcp_open(struct inode *inode, struct file *filp)
{
	MOD_INC_USE_COUNT; /* ٤1夲  #include <linux/devfs_fs_kernel.h> */
        return 0;
}

/*-------------------------------------------*/
/*    ts_dcp_release()                       */
/*-------------------------------------------*/
static int ts_dcp_release(struct inode *inode, struct file *filp)
{
	MOD_DEC_USE_COUNT; /* ٤1 */
	return 0;
}

/*-------------------------------------------*/
/*    ts_dcp_ioctl()                         */
/*-------------------------------------------*/
/* iocmd:桼ޥ, ioarg:ޥɤؤΰ */
static int ts_dcp_ioctl(struct inode *inode, struct file *file, unsigned int iocmd, unsigned long ioarg)
{
	int data;
	
	data = inw(TS_READ_ADDR);
	put_user(data, (int *)ioarg); /* 桼(ioarg)˽񤭹 */
	/* printk("TS and DCP data: %x from ts_dcp.o\n",data);
	*/
	return 0;
}

/* file_operations ¤ */
static struct file_operations ts_dcp_fops = {
	owner:    THIS_MODULE,
	read:     NULL,
	write:    NULL,
	ioctl:    ts_dcp_ioctl,
	open:     ts_dcp_open,
	release:  ts_dcp_release,
};



/*-------------------------------------------*/
/*    init_module                          */
/*-------------------------------------------*/
int init_module(void)
{
	if (register_chrdev(TS_DCP_MAJOR, "ts_dcp", &ts_dcp_fops)) {
	
		printk("ERROR: device registration error ts_dcp \n");
		return -EBUSY; /* return negative value */
	}	               /* EBUSY:16 Device or resource busy */
	return 0;
}

/*-------------------------------------------*/
/*    cleanup_module()                       */
/*-------------------------------------------*/
void cleanup_module(void)
{
	if (unregister_chrdev(TS_DCP_MAJOR, "ts_dcp")) {
		printk("ERROR: device unregistration error (ts_dcp)\n");
	}
}

