/*********************************************
 *        The Module to Stop The Motors      *
 *                                           *
 *               programed by Hideki Ohshima *
 *                     Ver 1.0  2001 Jan. 20 *
 *********************************************/

//#define MODULE
//#define __KERNEL__
//#define __RTL__ 
#include <linux/errno.h>
#include <asm/io.h>
#include <rtl.h>
#include <time.h>
#include <rtl_sched.h>
#include <rtl_fifo.h>
#include "pwm_enc.h"

/* IO Port Adress */
//#define PWM_LEFT_WRITE   0x0112
//#define PWM_RIGHT_WRITE  0x0110

pthread_t tasks[1];

void *motor_stop(void *t)
{
	int i;
	pthread_make_periodic_np(pthread_self(), gethrtime(), 100000000);
	for (i=0; i<=10; i++){
		int ret;
		ret = pthread_wait_np();
		outw(0x0000, PWM_LEFT_WRITE);  /* stop the left tire */
		outw(0x0000, PWM_RIGHT_WRITE); /* stop the right tire */
	}
	pthread_suspend_np(pthread_self());
	return 0;
}

/* #define DEBUG  */
int init_module(void)
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 1;
	pthread_attr_setschedparam (&attr, &sched_param);
	ret = pthread_create (&tasks[0], &attr, motor_stop, (void *)1);

	return 0;
}

void cleanup_module(void)
{
#ifdef DEBUG
	printk("%d\n", rtf_destroy(1));
#else
	rtf_destroy(1);
#endif
	pthread_delete_np (tasks[0]);
}
