/* made on December 9th 2001 by Hideki Ohshima */ 
#include <stdio.h>
#include <math.h>
#include <errno.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "pwm_enc.h"

#define adj           1.0
#define PWM_DATA_MAX  127

int data_write(int, int, int, int);

void pwm_both_data(int l_speed, int r_speed)
{
	int left_vdata, right_vdata;

	left_vdata = abs(l_speed) * PWM_DATA_MAX / 100;
	right_vdata = abs(r_speed) * PWM_DATA_MAX / 100;
	left_vdata = (l_speed >= 0) ? left_vdata + 128 : left_vdata;
	right_vdata = (r_speed >= 0) ? right_vdata + 128 : right_vdata;
	data_write(left_vdata, right_vdata, 0, DUTY_MODE);
}

void pwm_cm_data(int l_distance, int r_distance, int tup)
{
	int l_speed, r_speed;

	l_speed = (int)((l_distance / (diameter * pi)) * gear * cpr * adj);
	r_speed = (int)((r_distance / (diameter * pi)) * gear * cpr * adj);
//	l_speed = (int)(l_distance);
//	r_speed = (int)(r_distance);
	data_write(l_speed, r_speed, tup, STOP_MODE);
}

/* Secret Varsion */
void pwm_circle_data(int angle)
{
	int l_speed, r_speed;

	l_speed = (int)((intarval * angle / diameter) * gear * cpr / 360 * 1.00);
	r_speed = (int)((-1 * intarval * angle / diameter) * gear * cpr / 360 * 1.00);
	data_write(l_speed, r_speed,2, STOP_MODE);
}

int data_write(int left, int right, int Tup, int mode)
{
	int fd2;
	struct pwm_speed_data pwm;
	if ((fd2 = open("/dev/rtf4", O_WRONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf4\n");
                return 0;
        }
	pwm.l_speed = left;
	pwm.r_speed = right;
	pwm.tup = Tup;
	pwm.mode = mode;
	printf("PWMR=%d,PWML=%d\n",left,right);
        if (write(fd2, &pwm, sizeof(pwm)) < 0){
                fprintf(stderr, "Can't send a data to RT-task\n");
        }
	close(fd2);
	return 0;
}
