/* For the task control */
#define COMMAND_FIFO  5
#define START_TASK    1   
#define STOP_TASK     2  
#define RESTART_TASK  3  

/* For Rotary Encoder */
/* Data of tire & motor */
#define diameter      6.35  /* diameter of the tire [cm] */
#define pi         3.14
#define peri       0.02  /* execution period of RT-Task [sec] */
#define gear         16  /* gear ratio */
#define cpr         100  /* the number of counts a revolution */
#define intarval     22  /* the intarval between the tires */

/* For PWM */
#define KEEP_SPEED -999   
#define DUTY_MODE   123
#define STOP_MODE   456

/* define the I/O ports */
#define PWM_LEFT_WRITE   0x0110
#define PWM_RIGHT_WRITE  0x0112
#define LEFT_COUNTER     0x0120
#define RIGHT_COUNTER    0x0122

struct my_msg_struct{
	int command;     /* command to control RT-task */
	int task;        /* number of the RT-task */
	int period;      /* execution period of the RT-task */
};

struct count_data{
	int left_count;        /* pulses of left counter */
	int right_count;       /* pulses of right counter */
	int left_sum;    /* sum of puslses of left counter */
	int right_sum;    /* sum of puslses of right counter */
	int br;
};

struct send_data{
/*	double refl;
	double refr;
	double left_u;
	double right_u;
	int l_duty;
	int r_duty;*/
/*        double athetar;
        double athetal;
        double thetar;
        double thetal;*/
        double aomegar;
        double aomegal;
        double omegar;
        double omegal;
	double tn;
	int br;
};


struct pwm_speed_data{
	int l_speed;     /* velocity of left wheel */
	int r_speed;     /* velocity of right wheel */
	int tup;
	int mode;
};

