/*-----------------------------*/
/*      irs.cpp                */
/*     class Irs               */
/* 2003.11.17 MIRS0204         */
/*-----------------------------*/

#include <iostream.h>
#include <string.h> // memset(3)
#include <stdlib.h> /* exit(1) */
#include <unistd.h> /* close() */
#include <fcntl.h> /* open(2) */
#include <sys/ioctl.h> /* ioctl(2) */
#include "irs.h"

Irs::Irs(void) /* constructor */
{
	if ((fd = open("/dev/irs",O_RDONLY)) < 0) {
		cerr << "ERROR: irs can't open" << endl;
		exit(EXIT_FAILURE);
	}
	
	memset(value,0,sizeof(value));
	data = 3;

}

Irs::~Irs(void) /* destructor */
{
	close(fd);
}

Irs::operator int(void) /* intȤƻȤȤ */
{
	return fd;
}

// ͤIrs No.
int Irs::getValue(const int num)
{
	int i,select;
	memset(value,0,sizeof(value));
	if(num == 0){
		select = 0x2000; //13bit
	}else if(num == 1){
		select = 0x4000; //14bit
	}else{
		return EXIT_FAILURE;
	}
	ioctl(fd,select,&data); // set
	usleep(1000);
	ioctl(fd,10,&data); //read
	cout << data << endl;
	for(i=1;i<7;i++){
		if(((data >> i)& 0x0001) == 1){
			value[num] = i;
			break;
		}else if(i == 5){
			if(((data >> 15) & 0x0001) == 1){
				value[num] = 5;
				break;
			}
		}
	}
	return value[num];
}

//
#if 0
int Irs::getValue(const int num)
{
  /* num֤IRS  */
  int nv;
  if((num>=0)&&(num<=2)){
    nv = value[num];
  }else{
    cerr << "Irs::getValue(const int num), wrong arg." << endl;
    nv = -1;
  }
  return nv;
}
#endif

void Irs::showData(void)
{
	int d[16];
	int i;
	for(i=15;i>=0;i--){
		d[i] = (data >> i) & 0x0001;
		cout << d[i];
		if ((i % 4) == 0) {
			cout << " ";
		}
	}
	cout << '\n';
}
