/*-----------------------------*/
/*      move.cpp               */
/*     class Move              */
/* 2003.1.30 MIRS0204          */
/*-----------------------------*/

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include "pwm_enc.h"
#include "pwm.h"
#include "enc.h"
#include "move.h"
#include "passive.h"
#include "uss.h"
#include "irs.h"

Move::Move(void)
{
	
}

Move::~Move(void)
{
	
}
int Move::goStraight(void)
{
	Enc enc;
	Passive ts(ts);
	Passive wls(wls);
	Irs irs;
//	Uss uss;
	int u_left, u_right;
	int e_left, e_right;
	int count = 10;
	do{
		enc.reset();
		enc.getValue();
		e_left = enc.getDistance(left);
		e_right = enc.getDistance(right);
		if(count <= 20){
			u_left = 100 * count /20;
			u_right = 96 * count /20;
		}
		count++;
		if((e_left-e_right)>0){
			if(u_right != 100){
				u_right++;
			}else{
				u_left--;
			}
		}else if((e_left-e_right)<0){
			if(u_left != 100){
				u_left++;
			}else{
				u_right--;
			}
		}
		
		pwm.setPwm(u_left,u_right);
		Passive::scanData();
	}while(ts.getValue()==0 && wls.getValue()==0/* && irs.getValue(0)==0*/);
	pwm.setPwm(0,0);
	return 0;
}

int Move::goStraight(const int dist)
{
	Enc enc;
	Passive ts(ts);
	Passive wls(wls);
	int d_left, d_right;
	int e_left, e_right;
	int u_left, u_right;
	int count;
	count = 10;
	int sign;
	if(dist < 0){
		sign = -1;
	}else{
		sign =1;
	}

	do{
		// enc.reset();
		enc.getValue();
		d_left = enc.getDistance(left);
		d_right = enc.getDistance(right);
		e_left = dist - d_left;
		e_right = dist - d_right;
		if(count < 20){
			u_left = sign*100 * count / 20;
			u_right = sign*96 * count / 20;
		}
		count++;
		if(abs(d_left) > abs(d_right)){
			if(u_right != 100){
				u_right++;
			}else{
				u_left--;
			}
		}else if(abs(d_left) < abs(d_right)){
			if(u_left != 100){
				u_left++;
			}else{
				u_right--;
			}
		}
		if(abs(e_left) < abs(dist/10)){
			u_left = u_left / 2;
		}
		if(abs(e_right) < abs(dist/10)){
			u_right = u_right / 2;
		}
		pwm.setPwm(u_left, u_right);
		Passive::scanData();
	}while((abs(e_left)>=50 && abs(e_right)>=50)/* && ts.getValue()==0 && wls.getValue()==0*/);
	pwm.setPwm(0,0);
	return 0;
}
int Move::turn(int c)
{
	Passive dcp(dcp);
	int i,count;
	count = 0;
	while(count < c){
		i = dcp.getValue(on);
		do{
			pwm.setPwm(-80,80);
		}while(i == dcp.getValue(on) );
		count++;
	}	
	pwm.setPwm(0,0);
	return 0;	
}
int Move::turn(const double angle)
{
	Enc enc;
	int i,d_left,d_right;
	int u_left,u_right;
	int l_old,r_old;
	
	double angle_now;
	int dist,limit;
	dist = (int)(angle * PI * 260 * 0.9 / 360);
	u_left = 70;
	u_right = 67;
	l_old=0;
	r_old=0;
	limit = 100;
	do{
		enc.getValue();
		d_left = enc.getDistance(left);
		d_right = enc.getDistance(right);
		if((l_old==d_left) ||(r_old==d_right)) break;
		l_old=d_left;
		r_old=d_right;
		if(abs(d_left) > abs(d_right)){
			if(u_right < 100){
				u_right++;
			}else{
				u_left--;
			}
		}else if(abs(d_left) < abs(d_right)){
			if(u_left < 100){
				u_left++;
			}else{
				u_right--;
			}
		}

		if(angle > 0){
			pwm.setPwm(-u_left,u_right);
		}else{
			pwm.setPwm(u_left,-u_right);
		}
	}while(abs(d_right) < abs(dist));
	if(angle > 0){
		pwm.setPwm(20,-20);
	}else{
		pwm.setPwm(-20,20);
	}
	usleep(200000);
			
	pwm.setPwm(0,0);
	return 0;
}
int Move::turnUss(int *ussd)
{
	Uss uss;
	Passive dcp(dcp);
	int i,j,count=0,num=0,buf;
	int uss_data[1000];
	i = dcp.getValue(on);
	while(count < 15){
		j = dcp.getValue(on);
		do{
			pwm.setPwm(-60,60);
			buf = uss.getValue(3);
			if(buf > 200 && buf < 1500){
			//	uss_data[num][0] = buf;
				uss_data[num] = count;
				num++;
				return 0;
			}
			usleep(20000);
		}while(dcp.getValue(on) == j);
		count++;
	}
	ussd = uss_data;
	return num;
}

int Move::turnPost(void)
{
	Passive ts(ts);
	Irs irs;
	do{
		pwm.setPwm(80,100);
	}while(ts.getValue(on)==0 && irs.getValue(0)==0);
	pwm.setPwm(0,0);
	return 0;
}
void Move::stop(void)
{
	pwm.stopPwm();
}
