/*-----------------------------*/
/*      passive.cpp            */
/*     class Passive           */
/* 2004.1.22  MIRS0204         */
/*-----------------------------*/

#include <iostream.h>
#include <stdlib.h> /* exit(1) */
#include <unistd.h> /* close() */
#include <fcntl.h> /* open(2) */
#include <sys/ioctl.h> /* ioctl(2) */
#include "passive.h"

// static variables
int Passive::data = 0;
int Passive::fd = 0;
int Passive::instance = 0;

/* constructor */
Passive::Passive(const sensor s) 
{
	if(instance == 0){
		if ((fd = open("/dev/ts_dcp", O_RDONLY)) < 0) {
			cerr << "ERROR: ts_dcp can't open" << endl;
			exit(EXIT_FAILURE);
		}
	}
	
	mode = s;
	value = 0;
	
	instance++;

}

Passive::~Passive(void) /* destructor */
{
	instance--;
	if(instance == 0){
		close(fd);
	}
}

Passive::operator int(void) /* intƂĎQƂƂ */
{
	return fd;
}

int Passive::getValue(const scan sc)
{
	int i;
	if(sc == on){
		i = scanData();
	}else{
		i = 0;
	}
	if(i!=-1){
		switch(mode){
		case ts:
			// 00XX XXXX 0000 0000
			value = (data & 0x3F00) >> 8;
			break;
		case dcp:
			// 0000 0000 0000 0XXX
			value = data & 0x0007;
			break;
		case wls:
			// 0000 0000 000X X000
			value = (data & 0x0018) >> 3;
			break;
		}
	}else{
		cerr << "ioctl error: getValue()" << endl;
		return -1;
	}
	return value;
}

int Passive::getValue(const int num, const scan sc)
{
	int i=0;
	int ret;
	if(sc == on){
		i = getValue(on);
	}
	
	if(i==0){
		switch(mode){
		case ts:
			if((num>=0)&&(num<=5)){
				ret = (value >> num) & 0x0001;
			}else{
				cerr << "Passive::getValue(const int num), wrong arg." << endl;
				ret = -1;
			}
			break;
		case dcp:
			ret = -2;
			break;
		case wls:
			if((num==0)||(num==1)){
				ret = (value >> num) & 0x0001;
			}else{
				cerr << "Wls::getValue(const int num), wrong arg." << endl;
				ret = -1;
			}
			break;
		}
	}else{
		ret = -1;
	}
	return ret;
}

// static function
int Passive::scanData(void)
{
	if(instance != 0){
		int i;
		i = ioctl(fd,0,&data);
		return data;
	}else{
		return -1;
	}

}

void Passive::showData(void)
{
	int d[16];
	int i;
	for(i=15;i>=0;i--){
		d[i] = (data >> i) & 0x0001;
		cout << d[i];
		if ((i % 4) == 0) {
			cout << " ";
		}
	}
	cout << '\n';
}
